
#include<boost/lexical_cast.hpp> 
#include<vector>
#include<list>
#include<string>
#include<sstream>

#include "tools.hh"

using namespace std;

/**
 * search val in Set and return true if it is the case
 */
bool HATP_TOOLS::operator>>(Entity const* val, set<Entity*> const& Set) {
	for(set<Entity*>::const_iterator it = Set.begin() ; it != Set.end() ; ++it)
		if(*it == val) return true;
	return false;
}

/**
 * search val in Set and return true if it is the case
 */
bool HATP_TOOLS::operator>>(LightEntity const* val, set<LightEntity*> const& Set) {
	for(set<LightEntity*>::const_iterator it = Set.begin() ; it != Set.end() ; ++it)
		if(*it == val) return true;
	return false;
}

/**
 * return true if val is not in Set
 */
bool HATP_TOOLS::operator^=(Entity const* val, set<Entity*> const& Set) {
	for(set<Entity*>::const_iterator it = Set.begin() ; it != Set.end() ; ++it)
		if(*it == val) return false;
	return true;
}

/**
 * return true if val is not in Set
 */
bool HATP_TOOLS::operator^=(LightEntity const* val, set<LightEntity*> const& Set) {
	for(set<LightEntity*>::const_iterator it = Set.begin() ; it != Set.end() ; ++it)
		if(*it == val) return false;
	return true;
}

/**
 * insert val in the set if val is not NULL
 */
void HATP_TOOLS::operator<<=(std::set<Entity*>& Set, Entity* val) {
	if(val == NULL){
		cerr<<"WARNING Trying to insert NULL value in a set"<<endl;
		return;
	}
	Set.insert(val);
}

/**
 * insert val in the set if val is not NULL
 */
void HATP_TOOLS::operator<<=(std::set<LightEntity*>& Set, LightEntity* val) {
	if(val == NULL){
		cerr<<"WARNING Trying to insert NULL value in a set"<<endl;
		return;
	}
	Set.insert(val);
}

/**
 * remove val from the set if val is not NULL
 */
void HATP_TOOLS::operator>>=(std::set<Entity*>& Set, Entity* val) {
	if(val == NULL){
		cerr<<"WARNING Trying to remove NULL value from a set"<<endl;
		return;
	}
	std::set<Entity*>::iterator it;
	it = Set.find(val);
	if(it != Set.end()) Set.erase(it);
}

/**
 * remove val from the set if val is not NULL
 */
void HATP_TOOLS::operator>>=(std::set<LightEntity*>& Set, LightEntity* val) {
	if(val == NULL){
		cerr<<"WARNING Trying to remove NULL value from a set"<<endl;
		return;
	}
	std::set<LightEntity*>::iterator it;
	it = Set.find(val);
	if(it != Set.end()) Set.erase(it);
}
